diff -ruN vdr-2.3.9/menu.c vdr-2.4.0/menu.c
--- vdr-2.3.9/menu.c	2018-03-18 13:01:09.000000000 +0100
+++ vdr-2.4.0/menu.c	2018-04-14 12:24:41.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 4.69 2018/03/18 12:01:09 kls Exp $
+ * $Id: menu.c 4.74 2018/04/14 10:24:41 kls Exp $
  */
 
 #include "menu.h"
@@ -45,6 +45,7 @@
 #define MAXWAITFORCAMMENU  10 // seconds to wait for the CAM menu to open
 #define CAMMENURETRYTIMEOUT 3 // seconds after which opening the CAM menu is retried
 #define CAMRESPONSETIMEOUT  5 // seconds to wait for a response from a CAM
+#define PROGRESSTIMEOUT   100 // milliseconds to wait before updating the replay progress display
 #define MINFREEDISK       300 // minimum free disk space (in MB) required to start recording
 #define NODISKSPACEDELTA  300 // seconds between "Not enough disk space to start recording!" messages
 #define MAXCHNAMWIDTH      16 // maximum number of characters of channels' short names shown in schedules menus
@@ -1691,10 +1692,13 @@
         Timers->SetSyncStateKey(StateKeySVDRPRemoteTimersPoll);
      if (HasSubMenu())
         CloseSubMenu();
-     if (Update())
-        Display();
-     SetHelpKeys(Channels);
      }
+  if (Update()) {
+     LOCK_SCHEDULES_READ;
+     Display();
+     }
+  LOCK_CHANNELS_READ;
+  SetHelpKeys(Channels);
   return osContinue;
 }
 
@@ -1999,10 +2003,12 @@
         Timers->SetSyncStateKey(StateKeySVDRPRemoteTimersPoll);
      if (HasSubMenu())
         CloseSubMenu();
-     if (Update())
-        Display();
-     SetHelpKeys();
      }
+  if (Update()) {
+     LOCK_SCHEDULES_READ;
+     Display();
+     }
+  SetHelpKeys();
   return osContinue;
 }
 
@@ -3010,6 +3016,7 @@
      Clear();
      GetRecordingsSortMode(DirectoryName());
      Recordings->Sort();
+     cMenuRecordingItem *CurrentItem = NULL;
      cMenuRecordingItem *LastItem = NULL;
      for (const cRecording *Recording = Recordings->First(); Recording; Recording = Recordings->Next(Recording)) {
          if ((!filter || filter->Filter(Recording)) && (!base || (strstr(Recording->Name(), base) == Recording->Name() && Recording->Name()[strlen(base)] == FOLDERDELIMCHAR))) {
@@ -3035,15 +3042,16 @@
             if (LastItem || LastDir) {
                if (*path) {
                   if (strcmp(path, Recording->Folder()) == 0)
-                     SetCurrent(LastDir ? LastDir : LastItem);
+                     CurrentItem = LastDir ? LastDir : LastItem;
                   }
                else if (CurrentRecording && strcmp(CurrentRecording, Recording->FileName()) == 0)
-                  SetCurrent(LastDir ? LastDir : LastItem);
+                  CurrentItem = LastDir ? LastDir : LastItem;
                }
             if (LastDir)
                LastDir->IncrementCounter(Recording->IsNew());
             }
          }
+     SetCurrent(CurrentItem);
      if (Current() < 0)
         SetCurrent(Get(current)); // last resort, in case the recording was deleted
      SetMenuSortMode(RecordingsSortMode == rsmName ? msmName : msmTime);
@@ -4637,6 +4645,7 @@
   number = 0;
   timeout = true;
   lastPresent = lastFollowing = NULL;
+  cOsdProvider::OsdSizeChanged(osdState); // just to get the current state
   lastTime.Set();
   withInfo = Setup.ShowInfoOnChSwitch;
   displayChannel = Skins.Current()->DisplayChannel(withInfo);
@@ -5562,7 +5571,6 @@
   lastPlay = lastForward = false;
   lastSpeed = -2; // an invalid value
   timeoutShow = 0;
-  lastProgressUpdate = 0;
   timeSearchActive = false;
   cRecording Recording(fileName);
   cStatus::MsgReplaying(this, Recording.Name(), Recording.FileName(), true);
@@ -5726,43 +5734,39 @@
 bool cReplayControl::ShowProgress(bool Initial)
 {
   int Current, Total;
-  if (Initial || lastSpeed != -1 || time(NULL) - lastProgressUpdate >= 1) {
-     if (GetFrameNumber(Current, Total) && Total > 0) {
-        if (!visible) {
-           displayReplay = Skins.Current()->DisplayReplay(modeOnly);
-           displayReplay->SetMarks(&marks);
-           SetNeedsFastResponse(true);
-           visible = true;
-           }
-        if (Initial) {
-           if (*fileName) {
-              LOCK_RECORDINGS_READ;
-              if (const cRecording *Recording = Recordings->GetByName(fileName))
-                 displayReplay->SetRecording(Recording);
-              }
-           lastCurrent = lastTotal = -1;
-           }
-        if (Current != lastCurrent || Total != lastTotal) {
-           time(&lastProgressUpdate);
-           if (Setup.ShowRemainingTime || Total != lastTotal) {
-              int Index = Total;
-              if (Setup.ShowRemainingTime)
-                 Index = Current - Index;
-              displayReplay->SetTotal(IndexToHMSF(Index, false, FramesPerSecond()));
-              if (!Initial)
-                 displayReplay->Flush();
-              }
-           displayReplay->SetProgress(Current, Total);
-           if (!Initial)
-              displayReplay->Flush();
-           displayReplay->SetCurrent(IndexToHMSF(Current, displayFrames, FramesPerSecond()));
-           displayReplay->Flush();
-           lastCurrent = Current;
-           }
-        lastTotal = Total;
-        ShowMode();
-        return true;
+  if (!(Initial || updateTimer.TimedOut()))
+     return visible;
+  if (GetFrameNumber(Current, Total) && Total > 0) {
+     if (!visible) {
+        displayReplay = Skins.Current()->DisplayReplay(modeOnly);
+        displayReplay->SetMarks(&marks);
+        SetNeedsFastResponse(true);
+        visible = true;
+        }
+     if (Initial) {
+        if (*fileName) {
+           LOCK_RECORDINGS_READ;
+           if (const cRecording *Recording = Recordings->GetByName(fileName))
+              displayReplay->SetRecording(Recording);
+           }
+        lastCurrent = lastTotal = -1;
+        }
+     if (Current != lastCurrent || Total != lastTotal) {
+        if (Setup.ShowRemainingTime || Total != lastTotal) {
+           int Index = Total;
+           if (Setup.ShowRemainingTime)
+              Index = Current - Index;
+           displayReplay->SetTotal(IndexToHMSF(Index, false, FramesPerSecond()));
+           }
+        displayReplay->SetProgress(Current, Total);
+        displayReplay->SetCurrent(IndexToHMSF(Current, displayFrames, FramesPerSecond()));
+        displayReplay->Flush();
+        lastCurrent = Current;
         }
+     lastTotal = Total;
+     ShowMode();
+     updateTimer.Set(PROGRESSTIMEOUT);
+     return true;
      }
   return false;
 }
@@ -6005,8 +6009,6 @@
      return osEnd;
   if (Key == kNone && !marksModified)
      marks.Update();
-  if (Key != kNone)
-     lastProgressUpdate = 0;
   if (visible) {
      if (timeoutShow && time(NULL) > timeoutShow) {
         Hide();
diff -ruN vdr-2.3.9/menu.h vdr-2.4.0/menu.h
--- vdr-2.3.9/menu.h	2018-02-01 16:35:48.000000000 +0100
+++ vdr-2.4.0/menu.h	2018-04-14 12:24:41.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.h 4.6 2018/02/01 15:35:48 kls Exp $
+ * $Id: menu.h 4.8 2018/04/14 10:24:41 kls Exp $
  */
 
 #ifndef __MENU_H
@@ -300,7 +300,7 @@
   bool lastPlay, lastForward;
   int lastSpeed;
   time_t timeoutShow;
-  time_t lastProgressUpdate;
+  cTimeMs updateTimer;
   bool timeSearchActive, timeSearchHide;
   int timeSearchTime, timeSearchPos;
   void TimeSearchDisplay(void);
diff -ruN vdr-2.3.9/menuitems.c vdr-2.4.0/menuitems.c
--- vdr-2.3.9/menuitems.c	2015-09-08 12:25:23.000000000 +0200
+++ vdr-2.4.0/menuitems.c	2018-03-23 16:37:02.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.c 4.2 2015/09/08 10:25:23 kls Exp $
+ * $Id: menuitems.c 4.3 2018/03/23 15:37:02 kls Exp $
  */
 
 #include "menuitems.h"
@@ -1062,14 +1062,12 @@
 
 void cMenuEditTimeItem::Set(void)
 {
-  char buf[10];
   switch (pos) {
-    case 1:  snprintf(buf, sizeof(buf), "%01d-:--", hh / 10); break;
-    case 2:  snprintf(buf, sizeof(buf), "%02d:--", hh); break;
-    case 3:  snprintf(buf, sizeof(buf), "%02d:%01d-", hh, mm / 10); break;
-    default: snprintf(buf, sizeof(buf), "%02d:%02d", hh, mm);
+    case 1:  SetValue(cString::sprintf("%01d-:--", hh / 10)); break;
+    case 2:  SetValue(cString::sprintf("%02d:--", hh)); break;
+    case 3:  SetValue(cString::sprintf("%02d:%01d-", hh, mm / 10)); break;
+    default: SetValue(cString::sprintf("%02d:%02d", hh, mm));
     }
-  SetValue(buf);
 }
 
 eOSState cMenuEditTimeItem::ProcessKey(eKeys Key)
diff -ruN vdr-2.3.9/osd.c vdr-2.4.0/osd.c
--- vdr-2.3.9/osd.c	2018-01-25 16:09:09.000000000 +0100
+++ vdr-2.4.0/osd.c	2018-04-06 10:43:15.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 4.4 2018/01/25 15:09:09 kls Exp $
+ * $Id: osd.c 4.5 2018/04/06 08:43:15 kls Exp $
  */
 
 #include "osd.h"
@@ -839,7 +839,9 @@
 {
   // Fixed point scaling code based on www.inversereality.org/files/bitmapscaling.pdf
   // by deltener@mindtremors.com
-  cBitmap *b = new cBitmap(int(round(Width() * FactorX)), int(round(Height() * FactorY)), Bpp(), X0(), Y0());
+  int w = max(1, int(round(Width() * FactorX)));
+  int h = max(1, int(round(Height() * FactorY)));
+  cBitmap *b = new cBitmap(w, h, Bpp(), X0(), Y0());
   int RatioX = (Width() << 16) / b->Width();
   int RatioY = (Height() << 16) / b->Height();
   if (!AntiAlias || FactorX <= 1.0 && FactorY <= 1.0) {
diff -ruN vdr-2.3.9/osdbase.c vdr-2.4.0/osdbase.c
--- vdr-2.3.9/osdbase.c	2018-03-06 11:38:18.000000000 +0100
+++ vdr-2.4.0/osdbase.c	2018-03-24 12:47:45.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osdbase.c 4.4 2018/03/06 10:38:18 kls Exp $
+ * $Id: osdbase.c 4.5 2018/03/24 11:47:45 kls Exp $
  */
 
 #include "osdbase.h"
@@ -330,7 +330,8 @@
 {
   if (marked >= 0)
      SetStatus(NULL);
-  lastOffset = (current > first) ? current - first : 0;
+  if (current >= 0)
+     lastOffset = (current > first) ? current - first : 0;
   first = 0;
   current = marked = -1;
   cList<cOsdItem>::Clear();
diff -ruN vdr-2.3.9/peerdemo vdr-2.4.0/peerdemo
--- vdr-2.3.9/peerdemo	2018-03-09 11:49:48.000000000 +0100
+++ vdr-2.4.0/peerdemo	2018-04-10 19:20:58.000000000 +0200
@@ -7,7 +7,8 @@
 # It reacts properly to the SVDRP commands CONN, LSTT, POLL, PING and QUIT,
 # and thus seems like a regular VDR to other VDRs.
 #
-# (C) 2018 by Klaus Schmidinger <Klaus.Schmidinger@tvdr.de>
+# See the main source file 'vdr.c' for copyright information and
+# how to reach the author.
 
 use Getopt::Std;
 use IO::Socket;
diff -ruN vdr-2.3.9/shutdown.c vdr-2.4.0/shutdown.c
--- vdr-2.3.9/shutdown.c	2015-07-18 13:29:26.000000000 +0200
+++ vdr-2.4.0/shutdown.c	2018-03-23 16:39:21.000000000 +0100
@@ -6,7 +6,7 @@
  *
  * Original version written by Udo Richter <udo_richter@gmx.de>.
  *
- * $Id: shutdown.c 4.1 2015/07/18 11:29:26 kls Exp $
+ * $Id: shutdown.c 4.2 2018/03/23 15:39:21 kls Exp $
  */
 
 #include "shutdown.h"
@@ -69,10 +69,7 @@
         timedOut = true;
      if (counter != NewCounter) {
         counter = NewCounter;
-        char time[10];
-        snprintf(time, sizeof(time), "%d:%d0", counter > 0 ? counter / 6 : 0, counter > 0 ? counter % 6 : 0);
-        cString Message = cString::sprintf(message, time);
-        Skins.Message(mtStatus, Message);
+        Skins.Message(mtStatus, cString::sprintf(message, *cString::sprintf("%d:%d0", counter > 0 ? counter / 6 : 0, counter > 0 ? counter % 6 : 0)));
         return true;
         }
      }
diff -ruN vdr-2.3.9/svdrp.c vdr-2.4.0/svdrp.c
--- vdr-2.3.9/svdrp.c	2018-03-18 11:43:53.000000000 +0100
+++ vdr-2.4.0/svdrp.c	2018-03-19 13:16:33.000000000 +0100
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 4.36 2018/03/18 10:43:53 kls Exp $
+ * $Id: svdrp.c 4.37 2018/03/19 12:16:33 kls Exp $
  */
 
 #include "svdrp.h"
@@ -480,8 +480,11 @@
 
 bool cSVDRPClient::Execute(const char *Command, cStringList *Response)
 {
+  cStringList Dummy;
   if (Response)
      Response->Clear();
+  else
+     Response = &Dummy;
   return Send(Command) && Process(Response);
 }
 
diff -ruN vdr-2.3.9/vdr.c vdr-2.4.0/vdr.c
--- vdr-2.3.9/vdr.c	2018-03-04 15:00:29.000000000 +0100
+++ vdr-2.4.0/vdr.c	2018-04-10 15:24:43.000000000 +0200
@@ -1,7 +1,7 @@
 /*
  * vdr.c: Video Disk Recorder main program
  *
- * Copyright (C) 2000, 2003, 2006, 2008, 2013 Klaus Schmidinger
+ * Copyright (C) 2000-2018 Klaus Schmidinger
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.tvdr.de
  *
- * $Id: vdr.c 4.24 2018/03/04 14:00:29 kls Exp $
+ * $Id: vdr.c 4.25 2018/04/10 13:24:43 kls Exp $
  */
 
 #include <getopt.h>
